local MAIN_SKIN= "metalpatafoin"
local DROP_OBJ_ATTR= MAIN_SKIN..'dropped_obj'

if not this_template_allocation_run_only_once_give_a_unique_name_metal then
	rawset(_G, "this_template_allocation_run_only_once_give_a_unique_name_metal", true)
	
	freeslot("MT_DROPPED_METALBO")
	freeslot("S_DROPPED_METALBO")
end

addHook("MobjThinker", function(mo)
	local target = mo.target
	if not(target and target.valid and target.player and
			target.skin==MAIN_SKIN and
			(target.player.kartstuff[k_spinouttimer] or target.player.playerstate==PST_DEAD)
		)
	then
		P_RemoveMobj(mo)
		return
	end
end, MT_DROPPED_METALBO)

local function spawn_object(player)
	local dropped_object= P_SpawnMobj(player.mo.x, player.mo.y-40*FRACUNIT, player.mo.z+40*FRACUNIT, MT_DROPPED_METALBO)
	dropped_object.target= player.mo
	dropped_object.color= player.skincolor
    dropped_object.friction = 60*FRACUNIT/100
	P_SpawnShadowMobj(dropped_object)
end

addHook("ThinkFrame", do
	for player in players.iterate do
		if (not player.mo) or player.mo.skin~=MAIN_SKIN then continue end
		
		if (player.kartstuff[k_spinouttimer] or player.playerstate==PST_DEAD)
				and (not player[DROP_OBJ_ATTR])
		then
			player[DROP_OBJ_ATTR]= true
			spawn_object(player)
		elseif not (player.kartstuff[k_spinouttimer] or player.playerstate==PST_DEAD)
			and player[DROP_OBJ_ATTR]
		then
			player[DROP_OBJ_ATTR]= nil
		end
	end
end)